
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>MDSLibraries.HHPred_parser &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for MDSLibraries.HHPred_parser</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- coding: utf-8 -*-</span>

<span class="sd">&quot;&quot;&quot;</span>
<span class="sd">This script takes the .hhr files output by HHSuite and</span>
<span class="sd">turns the quite verbose file in to a fully tabulated</span>
<span class="sd">version with all the fields separated one, one line per</span>
<span class="sd">file. Thus, the file can be viewed simply in Excel etc.</span>
<span class="sd">It requires the non-standard pandas module.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># This program is free software: you can redistribute it and/or</span>
<span class="c1"># modify it under the terms of the GNU General Public License as</span>
<span class="c1"># published by the Free Software Foundation, either version 3 of</span>
<span class="c1"># the License, or (at your option) any later version.</span>

<span class="c1"># This program is distributed in the hope that it will be useful,</span>
<span class="c1"># but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<span class="c1"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the</span>
<span class="c1"># GNU General Public License for more details.</span>

<span class="c1"># The license for HHSuite remains with the authors. Please consult</span>
<span class="c1"># their licensce agreements before using this software, and ensure</span>
<span class="c1"># they are cited for any use. Run the script with -b to print rel-</span>
<span class="c1"># evant references.</span>


<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">import</span> <span class="nn">warnings</span>
<span class="kn">from</span> <span class="nn">io</span> <span class="kn">import</span> <span class="n">StringIO</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>

<span class="kn">import</span> <span class="nn">system_utility</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="s2">&quot;Massimo Domenico Sammito&quot;</span> <span class="c1">#based on Joe R. J. Healey</span>
<span class="n">__version__</span> <span class="o">=</span> <span class="s2">&quot;1.0.0&quot;</span>
<span class="n">__title__</span> <span class="o">=</span> <span class="s2">&quot;tabulateHHpred&quot;</span>
<span class="n">__license__</span> <span class="o">=</span> <span class="s2">&quot;GPLv3&quot;</span>
<span class="n">__author_email__</span> <span class="o">=</span> <span class="s2">&quot;mds83@cam.ac.uk&quot;</span> <span class="c1">#previous author email: J.R.J.Healey@warwick.ac.uk</span>

<span class="n">template</span> <span class="o">=</span> \
    <span class="sa">u</span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    ---|------|------------------------|----|-------|-------|------|-----|----|---------|--------------|</span>
<span class="sd">     No Hit    Short Desc               Prob E-value P-value  Score    SS Cols Query HMM  Template HMM</span>
<span class="sd">    &quot;&quot;&quot;</span>


<div class="viewcode-block" id="hhparse"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.hhparse">[docs]</a><span class="k">def</span> <span class="nf">hhparse</span><span class="p">(</span><span class="n">hhresult_file</span><span class="p">,</span> <span class="n">verbose</span><span class="p">):</span>
    <span class="sd">&#39;&#39;&#39;Convert HHpred&#39;s text-based output table in to a pandas dataframe&#39;&#39;&#39;</span>

    <span class="n">pattern</span> <span class="o">=</span> <span class="n">StringIO</span><span class="p">(</span><span class="n">system_utility</span><span class="o">.</span><span class="n">py2_3_unicode</span><span class="p">(</span><span class="n">template</span><span class="p">))</span><span class="o">.</span><span class="n">readlines</span><span class="p">()[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
    <span class="n">colBreaks</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">ch</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">pattern</span><span class="p">)</span> <span class="k">if</span> <span class="n">ch</span> <span class="o">==</span> <span class="s1">&#39;|&#39;</span><span class="p">]</span>
    <span class="n">widths</span> <span class="o">=</span> <span class="p">[</span><span class="n">j</span> <span class="o">-</span> <span class="n">i</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(([</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">colBreaks</span><span class="p">)[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">colBreaks</span><span class="p">)]</span>

    <span class="n">allread</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">alignments</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">hhresult_file</span><span class="p">,</span> <span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">allreadl</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">readlines</span><span class="p">()</span>
        <span class="n">align</span> <span class="o">=</span> <span class="kc">False</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">line</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">allreadl</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">line</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s2">&quot;No 1&quot;</span><span class="p">):</span> <span class="n">align</span> <span class="o">=</span> <span class="kc">True</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="n">align</span><span class="p">:</span> <span class="n">allread</span> <span class="o">+=</span> <span class="n">line</span>
            <span class="k">if</span> <span class="n">align</span> <span class="ow">and</span> <span class="n">line</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s2">&quot;&gt;&quot;</span><span class="p">):</span> <span class="n">alignments</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">line</span><span class="o">+</span><span class="n">allreadl</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">])</span>

    <span class="n">allread</span> <span class="o">=</span> <span class="n">StringIO</span><span class="p">(</span><span class="n">system_utility</span><span class="o">.</span><span class="n">py2_3_unicode</span><span class="p">(</span><span class="n">allread</span><span class="p">))</span>
    <span class="n">hhtable</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_fwf</span><span class="p">(</span><span class="n">allread</span><span class="p">,</span> <span class="n">skiprows</span><span class="o">=</span><span class="mi">8</span><span class="p">,</span> <span class="n">header</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">skipfooter</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">widths</span><span class="o">=</span><span class="n">widths</span><span class="p">)</span>
    <span class="n">alignments</span> <span class="o">=</span> <span class="p">[(</span><span class="n">p</span><span class="p">[</span><span class="mi">1</span><span class="p">:</span><span class="mi">5</span><span class="p">],</span> <span class="n">p</span><span class="p">[</span><span class="mi">6</span><span class="p">],</span> <span class="p">[</span><span class="nb">int</span><span class="p">(</span><span class="n">z</span><span class="p">[</span><span class="mi">11</span><span class="p">:</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span><span class="o">/</span><span class="mf">100.0</span> <span class="k">for</span> <span class="n">z</span> <span class="ow">in</span> <span class="n">p</span><span class="o">.</span><span class="n">split</span><span class="p">()</span> <span class="k">if</span> <span class="n">z</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s2">&quot;Identities=&quot;</span><span class="p">)][</span><span class="mi">0</span><span class="p">],</span> <span class="p">[</span><span class="nb">float</span><span class="p">(</span><span class="n">z</span><span class="p">[</span><span class="mi">11</span><span class="p">:</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span> <span class="k">for</span> <span class="n">z</span> <span class="ow">in</span> <span class="n">p</span><span class="o">.</span><span class="n">split</span><span class="p">()</span> <span class="k">if</span> <span class="n">z</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s2">&quot;Similarity=&quot;</span><span class="p">)][</span><span class="mi">0</span><span class="p">])</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">alignments</span><span class="p">]</span>
    <span class="n">hhtable</span> <span class="o">=</span> <span class="n">hhtable</span><span class="o">.</span><span class="n">assign</span><span class="p">(</span><span class="n">pdbid</span><span class="o">=</span><span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">([</span><span class="n">z</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">z</span> <span class="ow">in</span> <span class="n">alignments</span><span class="p">]),</span> <span class="n">chain</span><span class="o">=</span><span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">([</span><span class="n">z</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">z</span> <span class="ow">in</span> <span class="n">alignments</span><span class="p">]),</span> <span class="n">si</span><span class="o">=</span><span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">([</span><span class="n">z</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span> <span class="k">for</span> <span class="n">z</span> <span class="ow">in</span> <span class="n">alignments</span><span class="p">]),</span> <span class="n">sim</span><span class="o">=</span><span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">([</span><span class="n">z</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span> <span class="k">for</span> <span class="n">z</span> <span class="ow">in</span> <span class="n">alignments</span><span class="p">]))</span>
    <span class="k">if</span> <span class="n">verbose</span> <span class="ow">is</span> <span class="kc">True</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="n">hhtable</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">hhtable</span></div>

<div class="viewcode-block" id="print_MSA"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.print_MSA">[docs]</a><span class="k">def</span> <span class="nf">print_MSA</span><span class="p">(</span><span class="n">hhtable</span><span class="p">):</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Multiple Sequence Alignment inserted&quot;</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">row</span> <span class="ow">in</span> <span class="n">hhtable</span><span class="o">.</span><span class="n">iterrows</span><span class="p">():</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;&gt;&quot;</span> <span class="o">+</span> <span class="n">row</span><span class="p">[</span><span class="s2">&quot;Hit&quot;</span><span class="p">])</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">row</span><span class="p">[</span><span class="s2">&quot;msa&quot;</span><span class="p">])</span></div>

<div class="viewcode-block" id="write_MSA"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.write_MSA">[docs]</a><span class="k">def</span> <span class="nf">write_MSA</span><span class="p">(</span><span class="n">hhtable</span><span class="p">,</span> <span class="n">filename</span><span class="p">,</span><span class="n">target</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">targ_aln</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span><span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">target</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">targ_aln</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s2">&quot;&gt;&quot;</span><span class="o">+</span><span class="n">target</span><span class="o">+</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span>
            <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">targ_aln</span><span class="o">+</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span>

        <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">row</span> <span class="ow">in</span> <span class="n">hhtable</span><span class="o">.</span><span class="n">iterrows</span><span class="p">():</span>
            <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s2">&quot;&gt;&quot;</span> <span class="o">+</span> <span class="n">row</span><span class="p">[</span><span class="s2">&quot;Hit&quot;</span><span class="p">]</span><span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span>
            <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">row</span><span class="p">[</span><span class="s2">&quot;msa&quot;</span><span class="p">]</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="parse_MSA_and_update_hhtable"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.parse_MSA_and_update_hhtable">[docs]</a><span class="k">def</span> <span class="nf">parse_MSA_and_update_hhtable</span><span class="p">(</span><span class="n">hhmsa</span><span class="p">,</span><span class="n">hhtable</span><span class="p">):</span>
        <span class="n">msa</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">hhmsa</span><span class="p">,</span> <span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">alllines</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">readlines</span><span class="p">()</span>
            <span class="n">block</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
            <span class="n">prev</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="n">index</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span> <span class="c1">#to account for the template sequence</span>
            <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">line</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">alllines</span><span class="p">):</span>
                <span class="k">if</span> <span class="n">line</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s2">&quot;&gt;&quot;</span><span class="p">):</span>
                    <span class="k">if</span> <span class="n">prev</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span> <span class="n">msa</span><span class="p">[</span><span class="n">prev</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="n">block</span>
                    <span class="n">block</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
                    <span class="n">prev</span> <span class="o">=</span> <span class="kc">None</span>
                    <span class="k">if</span> <span class="n">index</span><span class="o">&lt;</span><span class="mi">0</span> <span class="ow">or</span> <span class="nb">any</span><span class="p">(</span><span class="n">hhtable</span><span class="p">[</span><span class="s2">&quot;Hit&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">isin</span><span class="p">([</span><span class="n">line</span><span class="p">[</span><span class="mi">1</span><span class="p">:</span><span class="mi">7</span><span class="p">]])):</span>
                        <span class="n">msa</span><span class="p">[</span><span class="n">index</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="n">line</span><span class="p">[</span><span class="mi">1</span><span class="p">:</span><span class="mi">7</span><span class="p">],</span><span class="s2">&quot;&quot;</span><span class="p">]</span>
                        <span class="n">prev</span> <span class="o">=</span> <span class="n">index</span>
                    <span class="n">index</span> <span class="o">+=</span> <span class="mi">1</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">block</span> <span class="o">+=</span> <span class="n">line</span>
            <span class="k">if</span> <span class="n">prev</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span> <span class="n">msa</span><span class="p">[</span><span class="n">prev</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="n">block</span>

        <span class="n">keys</span><span class="p">,</span> <span class="n">values</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">msa</span><span class="o">.</span><span class="n">items</span><span class="p">())</span>
        <span class="n">hits</span><span class="p">,</span><span class="n">aln</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">values</span><span class="p">)</span>
        <span class="n">hhtable</span> <span class="o">=</span> <span class="n">hhtable</span><span class="o">.</span><span class="n">assign</span><span class="p">(</span><span class="n">msa</span><span class="o">=</span><span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">(</span><span class="n">aln</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="n">keys</span><span class="p">))</span>
        <span class="k">return</span> <span class="n">msa</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">][</span><span class="mi">0</span><span class="p">],</span><span class="n">msa</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">][</span><span class="mi">1</span><span class="p">],</span><span class="n">hhtable</span></div>

<div class="viewcode-block" id="get_best_hit"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.get_best_hit">[docs]</a><span class="k">def</span> <span class="nf">get_best_hit</span><span class="p">(</span><span class="n">hhtable</span><span class="p">,</span> <span class="n">verbose</span><span class="p">):</span>
    <span class="n">top_hit</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">hhtable</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="s1">&#39;Hit&#39;</span><span class="p">])[</span><span class="mi">0</span><span class="p">:</span><span class="mi">4</span><span class="p">]</span>
    <span class="n">top_hit_full</span> <span class="o">=</span> <span class="n">hhtable</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="s1">&#39;Hit&#39;</span><span class="p">]</span>
    <span class="n">top_prob</span> <span class="o">=</span> <span class="n">hhtable</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="s1">&#39;Prob&#39;</span><span class="p">]</span>
    <span class="n">top_eval</span> <span class="o">=</span> <span class="n">hhtable</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="s1">&#39;E-value&#39;</span><span class="p">]</span>
    <span class="n">top_pval</span> <span class="o">=</span> <span class="n">hhtable</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="s1">&#39;P-value&#39;</span><span class="p">]</span>
    <span class="n">top_score</span> <span class="o">=</span> <span class="n">hhtable</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="s1">&#39;Score&#39;</span><span class="p">]</span>

    <span class="k">if</span> <span class="n">verbose</span> <span class="ow">is</span> <span class="kc">True</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Your best hit: (PDB ID | Probability | E-Value | P-Value | Score)&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_hit</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_prob</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_eval</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_pval</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span>
            <span class="n">top_score</span><span class="p">))</span>

    <span class="k">return</span> <span class="n">top_hit</span><span class="p">,</span> <span class="n">top_hit_full</span><span class="p">,</span> <span class="n">top_prob</span><span class="p">,</span> <span class="n">top_eval</span><span class="p">,</span> <span class="n">top_pval</span><span class="p">,</span> <span class="n">top_score</span></div>


<div class="viewcode-block" id="getFullDesc"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.getFullDesc">[docs]</a><span class="k">def</span> <span class="nf">getFullDesc</span><span class="p">(</span><span class="n">hhresult_file</span><span class="p">,</span> <span class="n">top_hit_full</span><span class="p">,</span> <span class="n">verbose</span><span class="p">):</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">hhresult_file</span><span class="p">,</span> <span class="s1">&#39;r&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">hrh</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">hrh</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">line</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s1">&#39;&gt;&#39;</span> <span class="o">+</span> <span class="n">top_hit_full</span><span class="p">):</span>
                <span class="n">full_desc</span> <span class="o">=</span> <span class="n">line</span><span class="o">.</span><span class="n">rstrip</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">verbose</span> <span class="ow">is</span> <span class="kc">True</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">full_desc</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">full_desc</span></div>


<div class="viewcode-block" id="getDOI"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.getDOI">[docs]</a><span class="k">def</span> <span class="nf">getDOI</span><span class="p">(</span><span class="n">top_hit</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Query the PDB REST API to get an associated DOI/Publication&quot;&quot;&quot;</span>
    <span class="kn">import</span> <span class="nn">requests</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">query</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;https://www.ebi.ac.uk/pdbe/api/pdb/entry/publications/&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_hit</span><span class="p">))</span>
        <span class="n">qjson</span> <span class="o">=</span> <span class="n">query</span><span class="o">.</span><span class="n">json</span><span class="p">()</span>
        <span class="n">doi</span> <span class="o">=</span> <span class="n">qjson</span><span class="p">[</span><span class="n">top_hit</span><span class="p">][</span><span class="mi">0</span><span class="p">][</span><span class="s1">&#39;doi&#39;</span><span class="p">]</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">doi</span><span class="p">:</span>
            <span class="n">doi</span> <span class="o">=</span> <span class="s2">&quot;No DOI found.&quot;</span>

    <span class="k">except</span> <span class="ne">KeyError</span><span class="p">:</span>
        <span class="n">doi</span> <span class="o">=</span> <span class="s2">&quot;Key error. ID likely deprecated.&quot;</span>

    <span class="k">return</span> <span class="n">doi</span></div>


<div class="viewcode-block" id="displayRefs"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.displayRefs">[docs]</a><span class="k">def</span> <span class="nf">displayRefs</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;Display relevant references&quot;&quot;&quot;</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;&#39;&#39;</span>
<span class="s1">    - The following publications pertain to HHSuite:</span>
<span class="s1">	- Alva V., Nam SZ., Söding J., Lupas AN. (2016)</span>
<span class="s1">	  The MPI bioinformatics Toolkit as an integrative platform for advanced protein sequence and structure analysis.</span>
<span class="s1">	  Nucleic Acids Res. pii: gkw348. PMID: 27131380</span>

<span class="s1">	- Remmert M., Biegert A., Hauser A., Söding J. (2011) HHblits: Lightning-fast iterative protein sequence searching by HMM-HMM alignment.</span>
<span class="s1">	  Nat Methods. 9(2):173-5. doi: 10.1038/nmeth.1818. PMID: 22198341</span>

<span class="s1">	- Söding J., Biegert A., Lupas AN. (2005) The HHpred interactive server for protein homology detection and structure prediction.</span>
<span class="s1">	  Nucleic Acids Res 33 (Web Server issue), W244-W248. PMID: 15980461</span>

<span class="s1">	- Söding J. (2005) Protein homology detection by HMM-HMM comparison.</span>
<span class="s1">	  Bioinformatics 21: 951-960. PMID: 15531603</span>

<span class="s1">	- Hildebrand A., Remmert A., Biegert A., Söding J. (2009) Fast and accurate automatic structure prediction with HHpred.</span>
<span class="s1">	  Proteins 77(Suppl 9):128-32. doi: 10.1002/prot.22499. PMID: 19626712</span>

<span class="s1">	- Meier A., Söding J. (2015) Automatic Prediction of Protein 3D Structures by Probabilistic Multi-template Homology Modeling.</span>
<span class="s1">	  PLoS Comput Biol. 11(10):e1004343. doi: 10.1371/journal.pcbi.1004343. PMID: 26496371</span>
<span class="s1">	&#39;&#39;&#39;</span><span class="p">)</span>
    <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span></div>


<div class="viewcode-block" id="parseArgs"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.parseArgs">[docs]</a><span class="k">def</span> <span class="nf">parseArgs</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;Parse commandline arguments&quot;&quot;&quot;</span>

    <span class="kn">import</span> <span class="nn">argparse</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">parser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span>
            <span class="n">description</span><span class="o">=</span><span class="s1">&#39;This script converts HHpreds verbose output in to a full table for subsequent analysis.&#39;</span><span class="p">)</span>
        <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
            <span class="s1">&#39;-i&#39;</span><span class="p">,</span>
            <span class="s1">&#39;--infile&#39;</span><span class="p">,</span>
            <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store&#39;</span><span class="p">,</span>
            <span class="n">help</span><span class="o">=</span><span class="s1">&#39;The HHpred output file to parse.&#39;</span><span class="p">)</span>
        <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
            <span class="s1">&#39;-v&#39;</span><span class="p">,</span>
            <span class="s1">&#39;--verbose&#39;</span><span class="p">,</span>
            <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">,</span>
            <span class="n">help</span><span class="o">=</span><span class="s1">&#39;Print additional messages to screen. Default behaviour is false, only the result would be printed to screen for piping etc.&#39;</span><span class="p">)</span>
        <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
            <span class="s1">&#39;-o&#39;</span><span class="p">,</span>
            <span class="s1">&#39;--outfile&#39;</span><span class="p">,</span>
            <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store&#39;</span><span class="p">,</span>
            <span class="n">default</span><span class="o">=</span><span class="s1">&#39;None&#39;</span><span class="p">,</span>
            <span class="n">help</span><span class="o">=</span><span class="s1">&#39;Output file name to store results in. If none provided, the default will be infile.tsv.&#39;</span><span class="p">)</span>
        <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
            <span class="s1">&#39;-b&#39;</span><span class="p">,</span>
            <span class="s1">&#39;--bibliography&#39;</span><span class="p">,</span>
            <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">,</span>
            <span class="n">help</span><span class="o">=</span><span class="s1">&#39;Display references.&#39;</span><span class="p">)</span>
        <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
            <span class="s1">&#39;-d&#39;</span><span class="p">,</span>
            <span class="s1">&#39;--doi&#39;</span><span class="p">,</span>
            <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">,</span>
            <span class="n">help</span><span class="o">=</span><span class="s1">&#39;Try to retrieve relevant publications from PDB RESTful API. Warning, this will significantly slow down the processing of results.&#39;</span><span class="p">)</span>
        <span class="n">args</span> <span class="o">=</span> <span class="n">parser</span><span class="o">.</span><span class="n">parse_args</span><span class="p">()</span>

    <span class="k">except</span><span class="p">:</span>
        <span class="nb">print</span>
        <span class="s2">&quot;An exception occured with argument parsing. Check your provided options.&quot;</span>
        <span class="n">traceback</span><span class="o">.</span><span class="n">print_exc</span><span class="p">()</span>

    <span class="k">return</span> <span class="n">parser</span><span class="o">.</span><span class="n">parse_args</span><span class="p">()</span></div>


<div class="viewcode-block" id="main"><a class="viewcode-back" href="../../MDSLibraries.HHPred_parser.html#MDSLibraries.HHPred_parser.main">[docs]</a><span class="k">def</span> <span class="nf">main</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;Make function calls and handle arguments for tabulateHHpred.py&quot;&quot;&quot;</span>
    <span class="n">args</span> <span class="o">=</span> <span class="n">parseArgs</span><span class="p">()</span>

    <span class="k">if</span> <span class="n">args</span><span class="o">.</span><span class="n">bibliography</span> <span class="ow">is</span> <span class="kc">True</span><span class="p">:</span>
        <span class="n">displayRefs</span><span class="p">()</span>

    <span class="n">verbose</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">verbose</span>
    <span class="n">hhresult_file</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">infile</span>

    <span class="n">indir</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">hhresult_file</span><span class="p">))</span>

    <span class="n">split</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">splitext</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">infile</span><span class="p">)</span>
    <span class="n">basename</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">split</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>

    <span class="k">if</span> <span class="n">args</span><span class="o">.</span><span class="n">outfile</span> <span class="ow">is</span> <span class="s1">&#39;None&#39;</span><span class="p">:</span>
        <span class="n">outfile</span> <span class="o">=</span> <span class="n">indir</span> <span class="o">+</span> <span class="s1">&#39;/&#39;</span> <span class="o">+</span> <span class="n">basename</span> <span class="o">+</span> <span class="s1">&#39;.tsv&#39;</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">outfile</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">outfile</span>

    <span class="c1"># Main code begins:</span>

    <span class="n">top_hit</span><span class="p">,</span> <span class="n">top_hit_full</span><span class="p">,</span> <span class="n">top_prob</span><span class="p">,</span> <span class="n">top_eval</span><span class="p">,</span> <span class="n">top_pval</span><span class="p">,</span> <span class="n">top_score</span> <span class="o">=</span> <span class="n">hhparse</span><span class="p">(</span><span class="n">hhresult_file</span><span class="p">,</span> <span class="n">verbose</span><span class="p">)</span>
    <span class="n">full_desc</span> <span class="o">=</span> <span class="n">getFullDesc</span><span class="p">(</span><span class="n">hhresult_file</span><span class="p">,</span> <span class="n">top_hit_full</span><span class="p">,</span> <span class="n">verbose</span><span class="p">)</span>

    <span class="n">row</span> <span class="o">=</span> <span class="p">(</span><span class="n">basename</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_hit</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_hit_full</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_prob</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span>
        <span class="n">top_eval</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_pval</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">top_score</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="n">full_desc</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">args</span><span class="o">.</span><span class="n">doi</span> <span class="ow">is</span> <span class="kc">True</span><span class="p">:</span>
        <span class="n">doi</span> <span class="o">=</span> <span class="n">getDOI</span><span class="p">(</span><span class="n">top_hit</span><span class="p">)</span>
        <span class="n">row</span> <span class="o">=</span> <span class="p">(</span><span class="n">row</span><span class="o">.</span><span class="n">rstrip</span><span class="p">(</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="n">doi</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span>

        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">outfile</span><span class="p">,</span> <span class="s1">&#39;w&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">ofh</span><span class="p">:</span>
            <span class="n">ofh</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">row</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">row</span><span class="p">)</span>

    <span class="k">elif</span> <span class="n">args</span><span class="o">.</span><span class="n">doi</span> <span class="ow">is</span> <span class="kc">False</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">outfile</span><span class="p">,</span> <span class="s1">&#39;w&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">ofh</span><span class="p">:</span>
            <span class="n">ofh</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">row</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">row</span><span class="p">)</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">main</span><span class="p">()</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>